Uses Dpmi,VFlat,strings,crt,fps;

var LFB_seg:dword;
    er:integer;
    i:dword;

begin
//  vfForceSoftware;
  writeln(' VFlat demonstration program by Dmitry Uvarov (C) 1999');
  writeln;
  i:=vfGetPhysAddress;
  if i=0 then writeln('using software linear framebuffer emulation') else
              writeln('using hardware linear framebuffer located at ',hex(i));
  writeln('initiating mode 640x460x8 with linear frame buffer...');
  writeln('press any key to continue...');
  readkey;
  er:=vfSetMode($101);
  if er<>0 then begin
       write('Error: ');
       case er of
          -1: writeln('software VFlat emulation not avaible (maybe running under Windows)');
          -2: writeln('this mode not supported');
          -3: writeln('error during mode initialization');
       end;
       writeln('VBE error code: ',vfGlobalError);
       exit;
  end;
  // get linear address of video surface
  LFB_seg:=vfGetBaseAddress;
  if LFB_seg=0 then begin
     vfCloseMode;
     writeln('Error: base address not obtained');
     exit;
  end;

  fpsStart;
  for i:=0 to 500000 do begin
    mem[LFB_seg + random(640*480)]:=random(255);
    fpsCalc;
  end;
  fpsSaveFPS;
  fpsEnd;
  readkey;
  vfCloseMode;
  writeln('test passed successfully');
  writeln('fps: ',fpsCurrentFPS:4:4);

end.